# sendbird_platform_sdk
Sendbird Platform API SDK

https://sendbird.com/docs/chat/v3/platform-api/getting-started/prepare-to-use-api

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.0.15
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://sendbird.com](https://sendbird.com)

## Requirements.

Python >=3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/sendbird/sendbird-platform-sdk-python.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/sendbird/sendbird-platform-sdk-python.git`)

Then import the package:
```python
import sendbird_platform_sdk
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import sendbird_platform_sdk
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import sendbird_platform_sdk
from pprint import pprint
from sendbird_platform_sdk.api import announcement_api
from sendbird_platform_sdk.model.get_detailed_open_rate_of_announcement_group_response import GetDetailedOpenRateOfAnnouncementGroupResponse
from sendbird_platform_sdk.model.get_statistics_daily_response import GetStatisticsDailyResponse
from sendbird_platform_sdk.model.get_statistics_monthly_response import GetStatisticsMonthlyResponse
from sendbird_platform_sdk.model.get_statistics_response import GetStatisticsResponse
from sendbird_platform_sdk.model.list_announcement_groups_response import ListAnnouncementGroupsResponse
from sendbird_platform_sdk.model.schedule_announcement_data import ScheduleAnnouncementData
from sendbird_platform_sdk.model.schedule_announcement_response import ScheduleAnnouncementResponse
from sendbird_platform_sdk.model.update_announcement_by_id_data import UpdateAnnouncementByIdData
from sendbird_platform_sdk.model.update_announcement_by_id_response import UpdateAnnouncementByIdResponse
from sendbird_platform_sdk.model.view_announcement_by_id_response import ViewAnnouncementByIdResponse
# Defining the host is optional and defaults to https://api-APP_ID.sendbird.com
# See configuration.py for a list of all supported configuration parameters.
configuration = sendbird_platform_sdk.Configuration(
    host = "https://api-APP_ID.sendbird.com"
)



# Enter a context with an instance of the API client
with sendbird_platform_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = announcement_api.AnnouncementApi(api_client)
    api_token = "{{API_TOKEN}}" # str | 
    announcement_group = "announcement_group_example" # str | 

    try:
        # Get detailed open rate of an announcement group
        api_response = api_instance.get_detailed_open_rate_of_announcement_group(api_token, announcement_group)
        pprint(api_response)
    except sendbird_platform_sdk.ApiException as e:
        print("Exception when calling AnnouncementApi->get_detailed_open_rate_of_announcement_group: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api-APP_ID.sendbird.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AnnouncementApi* | [**get_detailed_open_rate_of_announcement_group**](docs/AnnouncementApi.md#get_detailed_open_rate_of_announcement_group) | **GET** /v3/announcement_open_rate_by_group/{announcement_group} | Get detailed open rate of an announcement group
*AnnouncementApi* | [**get_statistics**](docs/AnnouncementApi.md#get_statistics) | **GET** /v3/announcement_stats/weekly | Get statistics - weekly
*AnnouncementApi* | [**get_statistics_daily**](docs/AnnouncementApi.md#get_statistics_daily) | **GET** /v3/announcement_stats/daily | Get statistics - daily
*AnnouncementApi* | [**get_statistics_monthly**](docs/AnnouncementApi.md#get_statistics_monthly) | **GET** /v3/announcement_stats/monthly | Get statistics - monthly
*AnnouncementApi* | [**list_announcement_groups**](docs/AnnouncementApi.md#list_announcement_groups) | **GET** /v3/announcement_group | List announcement groups
*AnnouncementApi* | [**schedule_announcement**](docs/AnnouncementApi.md#schedule_announcement) | **POST** /v3/announcements | Schedule an announcement
*AnnouncementApi* | [**update_announcement_by_id**](docs/AnnouncementApi.md#update_announcement_by_id) | **PUT** /v3/announcements/{unique_id} | Update an announcement
*AnnouncementApi* | [**view_announcement_by_id**](docs/AnnouncementApi.md#view_announcement_by_id) | **GET** /v3/announcements/{unique_id} | View an announcement
*ApplicationApi* | [**add_apns_push_configuration**](docs/ApplicationApi.md#add_apns_push_configuration) | **POST** /v3/applications/push/apns | Add an APNs push configuration
*ApplicationApi* | [**add_fcm_push_configuration**](docs/ApplicationApi.md#add_fcm_push_configuration) | **POST** /v3/applications/push/fcm | Add a FCM push configuration
*ApplicationApi* | [**add_hms_push_configuration**](docs/ApplicationApi.md#add_hms_push_configuration) | **POST** /v3/applications/push/hms | Add an HMS push configuration
*ApplicationApi* | [**add_ip_to_whitelist**](docs/ApplicationApi.md#add_ip_to_whitelist) | **PUT** /v3/applications/settings/ip_whitelist | Add an IP to a whitelist
*ApplicationApi* | [**ban_users_in_channels_with_custom_channel_type**](docs/ApplicationApi.md#ban_users_in_channels_with_custom_channel_type) | **POST** /v3/applications/settings_by_channel_custom_type/{custom_type}/ban | Ban users in channels with a custom channel type
*ApplicationApi* | [**configure_auto_event_messages**](docs/ApplicationApi.md#configure_auto_event_messages) | **PUT** /v3/applications/settings/auto_event_message | Configure auto event message settings
*ApplicationApi* | [**delete_allowed_ips_from_whitelist**](docs/ApplicationApi.md#delete_allowed_ips_from_whitelist) | **DELETE** /v3/applications/settings/ip_whitelist | Delete allowed IPs from a whitelist
*ApplicationApi* | [**delete_apns_certificate_by_id**](docs/ApplicationApi.md#delete_apns_certificate_by_id) | **DELETE** /v3/applications/push/apns/cert/{provider_id} | Delete an APNs certificate
*ApplicationApi* | [**generate_secondary_api_token**](docs/ApplicationApi.md#generate_secondary_api_token) | **POST** /v3/applications/api_tokens | Generate a secondary API token
*ApplicationApi* | [**list_auto_event_messages**](docs/ApplicationApi.md#list_auto_event_messages) | **GET** /v3/applications/settings/auto_event_message | List auto event messages
*ApplicationApi* | [**list_banned_users_in_channels_with_custom_channel_type**](docs/ApplicationApi.md#list_banned_users_in_channels_with_custom_channel_type) | **GET** /v3/applications/settings_by_channel_custom_type/{custom_type}/ban | List banned users in channels with a custom channel type
*ApplicationApi* | [**list_muted_users_in_channels_with_custom_channel_type**](docs/ApplicationApi.md#list_muted_users_in_channels_with_custom_channel_type) | **GET** /v3/applications/settings_by_channel_custom_type/{custom_type}/mute | List muted users in channels with a custom channel type
*ApplicationApi* | [**list_push_configurations**](docs/ApplicationApi.md#list_push_configurations) | **GET** /v3/applications/push/{push_type} | List push configurations
*ApplicationApi* | [**list_push_notification_content_templates**](docs/ApplicationApi.md#list_push_notification_content_templates) | **GET** /v3/applications/push/message_templates | List push notification content templates
*ApplicationApi* | [**list_secondary_api_tokens**](docs/ApplicationApi.md#list_secondary_api_tokens) | **GET** /v3/applications/api_tokens | List secondary API tokens
*ApplicationApi* | [**mute_users_in_channels_with_custom_channel_type**](docs/ApplicationApi.md#mute_users_in_channels_with_custom_channel_type) | **POST** /v3/applications/settings_by_channel_custom_type/{custom_type}/mute | Mute users in channels with a custom channel type
*ApplicationApi* | [**remove_push_configuration_by_id**](docs/ApplicationApi.md#remove_push_configuration_by_id) | **DELETE** /v3/applications/push/{push_type}/{provider_id} | Remove a push configuration
*ApplicationApi* | [**retrieve_ip_whitelist**](docs/ApplicationApi.md#retrieve_ip_whitelist) | **GET** /v3/applications/settings/ip_whitelist | Retrieve an IP whitelist
*ApplicationApi* | [**revoke_secondary_api_token_by_token**](docs/ApplicationApi.md#revoke_secondary_api_token_by_token) | **DELETE** /v3/applications/api_tokens/{api_token} | Revoke a secondary API token
*ApplicationApi* | [**set_domain_filter**](docs/ApplicationApi.md#set_domain_filter) | **PUT** /v3/applications/settings_global/{custom_type} | Message moderation
*ApplicationApi* | [**unban_users_in_channels_with_custom_channel_type**](docs/ApplicationApi.md#unban_users_in_channels_with_custom_channel_type) | **DELETE** /v3/applications/settings_by_channel_custom_type/{custom_type}/ban | Unban users in channels with a custom channel type
*ApplicationApi* | [**unmute_users_in_channels_with_custom_channel_type**](docs/ApplicationApi.md#unmute_users_in_channels_with_custom_channel_type) | **DELETE** /v3/applications/settings_by_channel_custom_type/{custom_type}/mute | Unmute users in channels with a custom channel type
*ApplicationApi* | [**update_apns_push_configuration_by_id**](docs/ApplicationApi.md#update_apns_push_configuration_by_id) | **PUT** /v3/applications/push/apns/{provider_id} | Update an APNs push configuration
*ApplicationApi* | [**update_default_channel_invitation_preference**](docs/ApplicationApi.md#update_default_channel_invitation_preference) | **PUT** /v3/applications/default_channel_invitation_preference | Update default channel invitation preference
*ApplicationApi* | [**update_fcm_push_configuration_by_id**](docs/ApplicationApi.md#update_fcm_push_configuration_by_id) | **PUT** /v3/applications/push/fcm/{provider_id} | Update a FCM push configuration
*ApplicationApi* | [**update_hms_push_configuration_by_id**](docs/ApplicationApi.md#update_hms_push_configuration_by_id) | **PUT** /v3/applications/push/hms/{provider_id} | Update an HMS push configuration
*ApplicationApi* | [**update_push_notification_content_template**](docs/ApplicationApi.md#update_push_notification_content_template) | **PUT** /v3/applications/push/message_templates/{template_name} | Update a push notification content template
*ApplicationApi* | [**view_default_channel_invitation_preference**](docs/ApplicationApi.md#view_default_channel_invitation_preference) | **GET** /v3/applications/default_channel_invitation_preference | View default channel invitation preference
*ApplicationApi* | [**view_push_configuration_by_id**](docs/ApplicationApi.md#view_push_configuration_by_id) | **GET** /v3/applications/push/{push_type}/{provider_id} | View a push configuration
*ApplicationApi* | [**view_push_notification_content_template**](docs/ApplicationApi.md#view_push_notification_content_template) | **GET** /v3/applications/push/message_templates/{template_name} | View a push notification content template
*ApplicationApi* | [**view_secondary_api_token_by_token**](docs/ApplicationApi.md#view_secondary_api_token_by_token) | **GET** /v3/applications/api_tokens/{api_token} | View a secondary API token
*BotApi* | [**create_bot**](docs/BotApi.md#create_bot) | **POST** /v3/bots | Create a bot
*BotApi* | [**delete_bot_by_id**](docs/BotApi.md#delete_bot_by_id) | **DELETE** /v3/bots/{bot_userid} | Delete a bot
*BotApi* | [**join_channels**](docs/BotApi.md#join_channels) | **POST** /v3/bots/{bot_userid}/channels | Join channels
*BotApi* | [**leave_channels**](docs/BotApi.md#leave_channels) | **DELETE** /v3/bots/{bot_userid}/channels | Leave channels - When leaving all channels
*BotApi* | [**leave_channels_by_url**](docs/BotApi.md#leave_channels_by_url) | **DELETE** /v3/bots/{bot_userid}/channels/{channel_url} | Leave channels - When leaving a channel by its channel URL
*BotApi* | [**list_bots**](docs/BotApi.md#list_bots) | **GET** /v3/bots | List bots
*BotApi* | [**send_bots_message**](docs/BotApi.md#send_bots_message) | **POST** /v3/bots/{bot_userid}/send | Send a bot&#39;s message
*BotApi* | [**update_bot_by_id**](docs/BotApi.md#update_bot_by_id) | **PUT** /v3/bots/{bot_userid} | Update a bot
*BotApi* | [**view_bot_by_id**](docs/BotApi.md#view_bot_by_id) | **GET** /v3/bots/{bot_userid} | View a bot
*DataExportApi* | [**list_data_exports_by_message_channel_or_user**](docs/DataExportApi.md#list_data_exports_by_message_channel_or_user) | **GET** /v3/export/{data_type} | List data exports by message, channel, or user
*DataExportApi* | [**register_and_schedule_data_export**](docs/DataExportApi.md#register_and_schedule_data_export) | **POST** /v3/export/{data_type} | Register and schedule a data export
*DataExportApi* | [**view_data_export_by_id**](docs/DataExportApi.md#view_data_export_by_id) | **GET** /v3/export/{data_type}/{request_id} | View a data export
*GroupChannelApi* | [**gc_accept_invitation**](docs/GroupChannelApi.md#gc_accept_invitation) | **PUT** /v3/group_channels/{channel_url}/accept | Accept an invitation
*GroupChannelApi* | [**gc_cancel_the_registration_of_operators**](docs/GroupChannelApi.md#gc_cancel_the_registration_of_operators) | **DELETE** /v3/group_channels/{channel_url}/operators | Cancel the registration of operators
*GroupChannelApi* | [**gc_check_if_member_by_id**](docs/GroupChannelApi.md#gc_check_if_member_by_id) | **GET** /v3/group_channels/{channel_url}/members/{user_id} | Check if member
*GroupChannelApi* | [**gc_create_channel**](docs/GroupChannelApi.md#gc_create_channel) | **POST** /v3/group_channels | Create a channel
*GroupChannelApi* | [**gc_decline_invitation**](docs/GroupChannelApi.md#gc_decline_invitation) | **PUT** /v3/group_channels/{channel_url}/decline | Decline an invitation
*GroupChannelApi* | [**gc_delete_channel_by_url**](docs/GroupChannelApi.md#gc_delete_channel_by_url) | **DELETE** /v3/group_channels/{channel_url} | Delete a channel
*GroupChannelApi* | [**gc_hide_or_archive_channel**](docs/GroupChannelApi.md#gc_hide_or_archive_channel) | **PUT** /v3/group_channels/{channel_url}/hide | Hide or archive a channel
*GroupChannelApi* | [**gc_invite_as_members**](docs/GroupChannelApi.md#gc_invite_as_members) | **POST** /v3/group_channels/{channel_url}/invite | Invite as members
*GroupChannelApi* | [**gc_join_channel**](docs/GroupChannelApi.md#gc_join_channel) | **PUT** /v3/group_channels/{channel_url}/join | Join a channel
*GroupChannelApi* | [**gc_leave_channel**](docs/GroupChannelApi.md#gc_leave_channel) | **PUT** /v3/group_channels/{channel_url}/leave | Leave a channel
*GroupChannelApi* | [**gc_list_channels**](docs/GroupChannelApi.md#gc_list_channels) | **GET** /v3/group_channels | List channels
*GroupChannelApi* | [**gc_list_members**](docs/GroupChannelApi.md#gc_list_members) | **GET** /v3/group_channels/{channel_url}/members | List members
*GroupChannelApi* | [**gc_list_operators**](docs/GroupChannelApi.md#gc_list_operators) | **GET** /v3/group_channels/{channel_url}/operators | List operators
*GroupChannelApi* | [**gc_register_operators**](docs/GroupChannelApi.md#gc_register_operators) | **POST** /v3/group_channels/{channel_url}/operators | Register operators
*GroupChannelApi* | [**gc_reset_chat_history**](docs/GroupChannelApi.md#gc_reset_chat_history) | **PUT** /v3/group_channels/{channel_url}/reset_user_history | Reset chat history
*GroupChannelApi* | [**gc_unhide_or_unarchive_channel**](docs/GroupChannelApi.md#gc_unhide_or_unarchive_channel) | **DELETE** /v3/group_channels/{channel_url}/hide | Unhide or unarchive a channel
*GroupChannelApi* | [**gc_update_channel_by_url**](docs/GroupChannelApi.md#gc_update_channel_by_url) | **PUT** /v3/group_channels/{channel_url} | Update a channel
*GroupChannelApi* | [**gc_view_channel_by_url**](docs/GroupChannelApi.md#gc_view_channel_by_url) | **GET** /v3/group_channels/{channel_url} | View a channel
*MessageApi* | [**add_emoji_categories**](docs/MessageApi.md#add_emoji_categories) | **POST** /v3/emoji_categories | Add emoji categories
*MessageApi* | [**add_emojis**](docs/MessageApi.md#add_emojis) | **POST** /v3/emojis | Add emojis
*MessageApi* | [**add_extra_data_to_message**](docs/MessageApi.md#add_extra_data_to_message) | **POST** /v3/{channel_type}/{channel_url}/messages/{message_id}/sorted_metaarray | Add extra data to a message
*MessageApi* | [**add_reaction_to_a_message**](docs/MessageApi.md#add_reaction_to_a_message) | **POST** /v3/{channel_type}/{channel_url}/messages/{message_id}/reactions | Add a reaction to a message
*MessageApi* | [**delete_emoji_by_key**](docs/MessageApi.md#delete_emoji_by_key) | **DELETE** /v3/emojis/{emoji_key} | Delete an emoji
*MessageApi* | [**delete_emoji_category_by_id**](docs/MessageApi.md#delete_emoji_category_by_id) | **DELETE** /v3/emoji_categories/{emoji_category_id} | Delete an emoji category
*MessageApi* | [**delete_message_by_id**](docs/MessageApi.md#delete_message_by_id) | **DELETE** /v3/{channel_type}/{channel_url}/messages/{message_id} | Delete a message
*MessageApi* | [**enable_reactions**](docs/MessageApi.md#enable_reactions) | **PUT** /v3/applications/settings/reactions | Enable reactions
*MessageApi* | [**gc_mark_all_messages_as_delivered**](docs/MessageApi.md#gc_mark_all_messages_as_delivered) | **PUT** /v3/group_channels/{channel_url}/messages/mark_as_delivered | Mark all messages as delivered
*MessageApi* | [**gc_mark_all_messages_as_read**](docs/MessageApi.md#gc_mark_all_messages_as_read) | **PUT** /v3/group_channels/{channel_url}/messages/mark_as_read | Mark all messages as read
*MessageApi* | [**gc_view_number_of_each_members_unread_messages**](docs/MessageApi.md#gc_view_number_of_each_members_unread_messages) | **GET** /v3/group_channels/{channel_url}/messages/unread_count | View number of each member&#39;s unread messages
*MessageApi* | [**get_emoji_by_key**](docs/MessageApi.md#get_emoji_by_key) | **GET** /v3/emojis/{emoji_key} | Get an emoji
*MessageApi* | [**get_emoji_category_by_id**](docs/MessageApi.md#get_emoji_category_by_id) | **GET** /v3/emoji_categories/{emoji_category_id} | Get an emoji category
*MessageApi* | [**list_all_emojis_and_emoji_categories**](docs/MessageApi.md#list_all_emojis_and_emoji_categories) | **GET** /v3/emoji_categories | List all emojis and emoji categories
*MessageApi* | [**list_announcements**](docs/MessageApi.md#list_announcements) | **GET** /v3/announcements | List announcements
*MessageApi* | [**list_emojis**](docs/MessageApi.md#list_emojis) | **GET** /v3/emojis | List emojis
*MessageApi* | [**list_messages**](docs/MessageApi.md#list_messages) | **GET** /v3/{channel_type}/{channel_url}/messages | List messages
*MessageApi* | [**list_reactions_of_message**](docs/MessageApi.md#list_reactions_of_message) | **GET** /v3/{channel_type}/{channel_url}/messages/{message_id}/reactions | List reactions of a message
*MessageApi* | [**migrate_messages_by_url**](docs/MessageApi.md#migrate_messages_by_url) | **POST** /v3/migration/{target_channel_url} | Migrate messages
*MessageApi* | [**remove_extra_data_from_message**](docs/MessageApi.md#remove_extra_data_from_message) | **DELETE** /v3/{channel_type}/{channel_url}/messages/{message_id}/sorted_metaarray | Remove extra data from a message
*MessageApi* | [**remove_reaction_from_a_message**](docs/MessageApi.md#remove_reaction_from_a_message) | **DELETE** /v3/{channel_type}/{channel_url}/messages/{message_id}/reactions | Remove a reaction from a message
*MessageApi* | [**send_message**](docs/MessageApi.md#send_message) | **POST** /v3/{channel_type}/{channel_url}/messages | Send a message
*MessageApi* | [**translate_message_into_other_languages**](docs/MessageApi.md#translate_message_into_other_languages) | **POST** /v3/{channel_type}/{channel_url}/messages/{message_id}/translation | Translate a message into other languages
*MessageApi* | [**update_emoji_category_url_by_id**](docs/MessageApi.md#update_emoji_category_url_by_id) | **PUT** /v3/emoji_categories/{emoji_category_id} | Update an emoji category URL
*MessageApi* | [**update_emoji_url_by_key**](docs/MessageApi.md#update_emoji_url_by_key) | **PUT** /v3/emojis/{emoji_key} | Update an emoji URL
*MessageApi* | [**update_extra_data_in_message**](docs/MessageApi.md#update_extra_data_in_message) | **PUT** /v3/{channel_type}/{channel_url}/messages/{message_id}/sorted_metaarray | Update extra data in a message
*MessageApi* | [**update_message_by_id**](docs/MessageApi.md#update_message_by_id) | **PUT** /v3/{channel_type}/{channel_url}/messages/{message_id} | Update a message
*MessageApi* | [**use_default_emojis**](docs/MessageApi.md#use_default_emojis) | **PUT** /v3/applications/settings/use_default_emoji | Use default emojis
*MessageApi* | [**view_message_by_id**](docs/MessageApi.md#view_message_by_id) | **GET** /v3/{channel_type}/{channel_url}/messages/{message_id} | View a message
*MessageApi* | [**view_total_number_of_messages_in_channel**](docs/MessageApi.md#view_total_number_of_messages_in_channel) | **GET** /v3/{channel_type}/{channel_url}/messages/total_count | View total number of messages in a channel
*MetadataApi* | [**create_channel_metacounter**](docs/MetadataApi.md#create_channel_metacounter) | **POST** /v3/{channel_type}/{channel_url}/metacounter | Create a channel metacounter
*MetadataApi* | [**create_channel_metadata**](docs/MetadataApi.md#create_channel_metadata) | **POST** /v3/{channel_type}/{channel_url}/metadata | Create a channel metadata
*MetadataApi* | [**create_user_metadata**](docs/MetadataApi.md#create_user_metadata) | **POST** /v3/users/{user_id}/metadata | Create a user metadata
*MetadataApi* | [**delete_channel_metacounter**](docs/MetadataApi.md#delete_channel_metacounter) | **DELETE** /v3/{channel_type}/{channel_url}/metacounter | Delete a channel metacounter - When deleting all items of a channel metacounter
*MetadataApi* | [**delete_channel_metacounter_by_key**](docs/MetadataApi.md#delete_channel_metacounter_by_key) | **DELETE** /v3/{channel_type}/{channel_url}/metacounter/{key} | Delete a channel metacounter - When deleting a specific item of a channel metacounter by its key
*MetadataApi* | [**delete_channel_metadata**](docs/MetadataApi.md#delete_channel_metadata) | **DELETE** /v3/{channel_type}/{channel_url}/metadata | Delete a channel metadata - When deleting all items of a channel metadata
*MetadataApi* | [**delete_channel_metadata_by_key**](docs/MetadataApi.md#delete_channel_metadata_by_key) | **DELETE** /v3/{channel_type}/{channel_url}/metadata/{key} | Delete a channel metadata - When deleting a specific item of a channel metadata by its key
*MetadataApi* | [**delete_user_metadata**](docs/MetadataApi.md#delete_user_metadata) | **DELETE** /v3/users/{user_id}/metadata | Delete a user metadata - When deleting all items of a user metadata
*MetadataApi* | [**delete_user_metadata_by_key**](docs/MetadataApi.md#delete_user_metadata_by_key) | **DELETE** /v3/users/{user_id}/metadata/{key} | Delete a user metadata - When deleting a specific item of a user metadata by its key
*MetadataApi* | [**update_channel_metacounter**](docs/MetadataApi.md#update_channel_metacounter) | **PUT** /v3/{channel_type}/{channel_url}/metacounter | Update a channel metacounter - When updating existing items of a channel metacounter by their keys or adding new items to the metacounter
*MetadataApi* | [**update_channel_metacounter_by_key**](docs/MetadataApi.md#update_channel_metacounter_by_key) | **PUT** /v3/{channel_type}/{channel_url}/metacounter/{key} | Update a channel metacounter - When updating a specific item of a channel metacounter by its key
*MetadataApi* | [**update_channel_metadata**](docs/MetadataApi.md#update_channel_metadata) | **PUT** /v3/{channel_type}/{channel_url}/metadata | Update a channel metadata - When updating existing items of a channel metadata by their keys or adding new items to the metadata
*MetadataApi* | [**update_channel_metadata_by_key**](docs/MetadataApi.md#update_channel_metadata_by_key) | **PUT** /v3/{channel_type}/{channel_url}/metadata/{key} | Update a channel metadata - When updating a specific item of a channel metadata by its key
*MetadataApi* | [**update_user_metadata**](docs/MetadataApi.md#update_user_metadata) | **PUT** /v3/users/{user_id}/metadata | Update a user metadata - When updating existing items of a user metadata by their keys or adding new items to the metadata
*MetadataApi* | [**update_user_metadata_by_key**](docs/MetadataApi.md#update_user_metadata_by_key) | **PUT** /v3/users/{user_id}/metadata/{key} | Update a user metadata - When updating a specific item of a user metadata by its key
*MetadataApi* | [**view_channel_metacounter**](docs/MetadataApi.md#view_channel_metacounter) | **GET** /v3/{channel_type}/{channel_url}/metacounter | View a channel metacounter - When retrieving all items of a channel metacounter
*MetadataApi* | [**view_channel_metacounter_by_key**](docs/MetadataApi.md#view_channel_metacounter_by_key) | **GET** /v3/{channel_type}/{channel_url}/metacounter/{key} | View a channel metacounter - When retrieving a specific item of a channel metacounter by its key
*MetadataApi* | [**view_channel_metadata**](docs/MetadataApi.md#view_channel_metadata) | **GET** /v3/{channel_type}/{channel_url}/metadata | View a channel metadata - When retrieving all items of a channel metadata
*MetadataApi* | [**view_channel_metadata_by_key**](docs/MetadataApi.md#view_channel_metadata_by_key) | **GET** /v3/{channel_type}/{channel_url}/metadata/{key} | View a channel metadata - When retrieving a specific item of a channel metadata by its key
*MetadataApi* | [**view_user_metadata**](docs/MetadataApi.md#view_user_metadata) | **GET** /v3/users/{user_id}/metadata | View a user metadata - When retrieving all items of a user metadata
*MetadataApi* | [**view_user_metadata_by_key**](docs/MetadataApi.md#view_user_metadata_by_key) | **GET** /v3/users/{user_id}/metadata/{key} | View a user metadata - When retrieving a specific item of a user metadata by its key
*ModerationApi* | [**ban_from_channels_with_custom_channel_types**](docs/ModerationApi.md#ban_from_channels_with_custom_channel_types) | **POST** /v3/users/{user_id}/banned_channel_custom_types | Ban from channels with custom channel types
*ModerationApi* | [**block_user**](docs/ModerationApi.md#block_user) | **POST** /v3/users/{user_id}/block | Block a user
*ModerationApi* | [**gc_ban_user**](docs/ModerationApi.md#gc_ban_user) | **POST** /v3/group_channels/{channel_url}/ban | Ban a user
*ModerationApi* | [**gc_freeze_channel**](docs/ModerationApi.md#gc_freeze_channel) | **PUT** /v3/group_channels/{channel_url}/freeze | Freeze a channel
*ModerationApi* | [**gc_list_banned_users**](docs/ModerationApi.md#gc_list_banned_users) | **GET** /v3/group_channels/{channel_url}/ban | List banned users
*ModerationApi* | [**gc_list_muted_users**](docs/ModerationApi.md#gc_list_muted_users) | **GET** /v3/group_channels/{channel_url}/mute | List muted users
*ModerationApi* | [**gc_mute_user**](docs/ModerationApi.md#gc_mute_user) | **POST** /v3/group_channels/{channel_url}/mute | Mute a user
*ModerationApi* | [**gc_unban_user_by_id**](docs/ModerationApi.md#gc_unban_user_by_id) | **DELETE** /v3/group_channels/{channel_url}/ban/{banned_user_id} | Unban a user
*ModerationApi* | [**gc_unmute_user_by_id**](docs/ModerationApi.md#gc_unmute_user_by_id) | **DELETE** /v3/group_channels/{channel_url}/mute/{muted_user_id} | Unmute a user
*ModerationApi* | [**gc_update_ban_by_id**](docs/ModerationApi.md#gc_update_ban_by_id) | **PUT** /v3/group_channels/{channel_url}/ban/{banned_user_id} | Update a ban
*ModerationApi* | [**gc_view_ban_by_id**](docs/ModerationApi.md#gc_view_ban_by_id) | **GET** /v3/group_channels/{channel_url}/ban/{banned_user_id} | View a ban
*ModerationApi* | [**gc_view_mute_by_id**](docs/ModerationApi.md#gc_view_mute_by_id) | **GET** /v3/group_channels/{channel_url}/mute/{muted_user_id} | View a mute
*ModerationApi* | [**list_banned_channels**](docs/ModerationApi.md#list_banned_channels) | **GET** /v3/users/{user_id}/ban | List banned channels
*ModerationApi* | [**list_blocked_users**](docs/ModerationApi.md#list_blocked_users) | **GET** /v3/users/{user_id}/block | List blocked users
*ModerationApi* | [**list_muted_channels**](docs/ModerationApi.md#list_muted_channels) | **GET** /v3/users/{user_id}/mute | List muted channels
*ModerationApi* | [**mute_in_channels_with_custom_channel_types**](docs/ModerationApi.md#mute_in_channels_with_custom_channel_types) | **POST** /v3/users/{user_id}/muted_channel_custom_types | Mute in channels with custom channel types
*ModerationApi* | [**oc_ban_user**](docs/ModerationApi.md#oc_ban_user) | **POST** /v3/open_channels/{channel_url}/ban | Ban a user
*ModerationApi* | [**oc_freeze_channel**](docs/ModerationApi.md#oc_freeze_channel) | **PUT** /v3/open_channels/{channel_url}/freeze | Freeze a channel
*ModerationApi* | [**oc_list_banned_users**](docs/ModerationApi.md#oc_list_banned_users) | **GET** /v3/open_channels/{channel_url}/ban | List banned users
*ModerationApi* | [**oc_list_muted_users**](docs/ModerationApi.md#oc_list_muted_users) | **GET** /v3/open_channels/{channel_url}/mute | List muted users
*ModerationApi* | [**oc_mute_user**](docs/ModerationApi.md#oc_mute_user) | **POST** /v3/open_channels/{channel_url}/mute | Mute a user
*ModerationApi* | [**oc_unban_user_by_id**](docs/ModerationApi.md#oc_unban_user_by_id) | **DELETE** /v3/open_channels/{channel_url}/ban/{banned_user_id} | Unban a user
*ModerationApi* | [**oc_unmute_user_by_id**](docs/ModerationApi.md#oc_unmute_user_by_id) | **DELETE** /v3/open_channels/{channel_url}/mute/{muted_user_id} | Unmute a user
*ModerationApi* | [**oc_update_ban_by_id**](docs/ModerationApi.md#oc_update_ban_by_id) | **PUT** /v3/open_channels/{channel_url}/ban/{banned_user_id} | Update a ban
*ModerationApi* | [**oc_view_ban_by_id**](docs/ModerationApi.md#oc_view_ban_by_id) | **GET** /v3/open_channels/{channel_url}/ban/{banned_user_id} | View a ban
*ModerationApi* | [**oc_view_mute_by_id**](docs/ModerationApi.md#oc_view_mute_by_id) | **GET** /v3/open_channels/{channel_url}/mute/{muted_user_id} | View a mute
*ModerationApi* | [**unblock_user_by_id**](docs/ModerationApi.md#unblock_user_by_id) | **DELETE** /v3/users/{user_id}/block/{target_id} | Unblock a user
*OpenChannelApi* | [**oc_cancel_the_registration_of_operators**](docs/OpenChannelApi.md#oc_cancel_the_registration_of_operators) | **DELETE** /v3/open_channels/{channel_url}/operators | Cancel the registration of operators
*OpenChannelApi* | [**oc_create_channel**](docs/OpenChannelApi.md#oc_create_channel) | **POST** /v3/open_channels | Create a channel
*OpenChannelApi* | [**oc_delete_channel_by_url**](docs/OpenChannelApi.md#oc_delete_channel_by_url) | **DELETE** /v3/open_channels/{channel_url} | Delete a channel
*OpenChannelApi* | [**oc_list_channels**](docs/OpenChannelApi.md#oc_list_channels) | **GET** /v3/open_channels | List channels
*OpenChannelApi* | [**oc_list_operators**](docs/OpenChannelApi.md#oc_list_operators) | **GET** /v3/open_channels/{channel_url}/operators | List operators
*OpenChannelApi* | [**oc_list_participants**](docs/OpenChannelApi.md#oc_list_participants) | **GET** /v3/open_channels/{channel_url}/participants | List participants
*OpenChannelApi* | [**oc_register_operators**](docs/OpenChannelApi.md#oc_register_operators) | **POST** /v3/open_channels/{channel_url}/operators | Register operators
*OpenChannelApi* | [**oc_update_channel_by_url**](docs/OpenChannelApi.md#oc_update_channel_by_url) | **PUT** /v3/open_channels/{channel_url} | Update a channel
*OpenChannelApi* | [**oc_view_channel_by_url**](docs/OpenChannelApi.md#oc_view_channel_by_url) | **GET** /v3/open_channels/{channel_url} | View a channel
*PrivacyApi* | [**cancel_the_registration_of_gdpr_request_by_id**](docs/PrivacyApi.md#cancel_the_registration_of_gdpr_request_by_id) | **DELETE** /v3/privacy/gdpr/{request_id} | Cancel the registration of a GDPR request
*PrivacyApi* | [**list_gdpr_requests**](docs/PrivacyApi.md#list_gdpr_requests) | **GET** /v3/privacy/gdpr | List GDPR requests
*PrivacyApi* | [**register_gdpr_request**](docs/PrivacyApi.md#register_gdpr_request) | **POST** /v3/privacy/gdpr | Register a GDPR request
*PrivacyApi* | [**view_gdpr_request_by_id**](docs/PrivacyApi.md#view_gdpr_request_by_id) | **GET** /v3/privacy/gdpr/{request_id} | View a GDPR request
*ReportApi* | [**list_reports**](docs/ReportApi.md#list_reports) | **GET** /v3/report | List reports
*ReportApi* | [**list_reports_on_channel_by_url**](docs/ReportApi.md#list_reports_on_channel_by_url) | **GET** /v3/report/{channel_type}/{channel_url} | List reports on a channel
*ReportApi* | [**list_reports_on_message_by_id**](docs/ReportApi.md#list_reports_on_message_by_id) | **GET** /v3/report/{channel_type}/{channel_url}/messages/{message_id} | List reports on a message
*ReportApi* | [**list_reports_on_user_by_id**](docs/ReportApi.md#list_reports_on_user_by_id) | **GET** /v3/report/users/{offending_user_id} | List reports on a user
*ReportApi* | [**report_channel_by_url**](docs/ReportApi.md#report_channel_by_url) | **POST** /v3/report/{channel_type}/{channel_url} | Report a channel
*ReportApi* | [**report_message_by_id**](docs/ReportApi.md#report_message_by_id) | **POST** /v3/report/{channel_type}/{channel_url}/messages/{message_id} | Report a message
*ReportApi* | [**report_user_by_id**](docs/ReportApi.md#report_user_by_id) | **POST** /v3/report/users/{offending_user_id} | Report a user
*ReportApi* | [**view_moderated_message_by_id**](docs/ReportApi.md#view_moderated_message_by_id) | **GET** /v3/report/{channel_type}/{channel_url}/profanity_messages/{message_id} | View a moderated message
*StatisticsApi* | [**get_detailed_open_rate_of_announcement_by_id**](docs/StatisticsApi.md#get_detailed_open_rate_of_announcement_by_id) | **GET** /v3/announcement_open_rate/{unique_id} | Get detailed open rate of an announcement
*StatisticsApi* | [**get_detailed_open_status_of_announcement_by_id**](docs/StatisticsApi.md#get_detailed_open_status_of_announcement_by_id) | **GET** /v3/announcement_open_status/{unique_id} | Get detailed open status of an announcement
*StatisticsApi* | [**retrieve_advanced_analytics_metrics**](docs/StatisticsApi.md#retrieve_advanced_analytics_metrics) | **GET** /v3/statistics/metric | Retrieve Advanced analytics metrics
*StatisticsApi* | [**view_number_of_concurrent_connections**](docs/StatisticsApi.md#view_number_of_concurrent_connections) | **GET** /v3/applications/ccu | View number of concurrent connections
*StatisticsApi* | [**view_number_of_daily_active_users**](docs/StatisticsApi.md#view_number_of_daily_active_users) | **GET** /v3/applications/dau | View number of daily active users
*StatisticsApi* | [**view_number_of_monthly_active_users**](docs/StatisticsApi.md#view_number_of_monthly_active_users) | **GET** /v3/applications/mau | View number of monthly active users
*StatisticsApi* | [**view_number_of_peak_connections**](docs/StatisticsApi.md#view_number_of_peak_connections) | **GET** /v3/applications/peak_connections | View number of peak connections
*UserApi* | [**add_registration_or_device_token**](docs/UserApi.md#add_registration_or_device_token) | **POST** /v3/users/{user_id}/push/{token_type} | Add a registration or device token
*UserApi* | [**choose_push_notification_content_template**](docs/UserApi.md#choose_push_notification_content_template) | **PUT** /v3/users/{user_id}/push/template | Choose a push notification content template
*UserApi* | [**create_user**](docs/UserApi.md#create_user) | **POST** /v3/users | Create a user
*UserApi* | [**create_user_token**](docs/UserApi.md#create_user_token) | **POST** /v3/users/{user_id}/token | Create user token
*UserApi* | [**delete_user_by_id**](docs/UserApi.md#delete_user_by_id) | **DELETE** /v3/users/{user_id} | Delete a user
*UserApi* | [**leave_my_group_channels**](docs/UserApi.md#leave_my_group_channels) | **PUT** /v3/users/{user_id}/my_group_channels/leave | Leave my group channels
*UserApi* | [**list_my_group_channels**](docs/UserApi.md#list_my_group_channels) | **GET** /v3/users/{user_id}/my_group_channels | List my group channels
*UserApi* | [**list_registration_or_device_tokens**](docs/UserApi.md#list_registration_or_device_tokens) | **GET** /v3/users/{user_id}/push/{token_type} | List registration or device tokens
*UserApi* | [**list_users**](docs/UserApi.md#list_users) | **GET** /v3/users | List users
*UserApi* | [**mark_all_messages_as_read**](docs/UserApi.md#mark_all_messages_as_read) | **PUT** /v3/users/{user_id}/mark_as_read_all | Mark all messages as read
*UserApi* | [**register_as_operator_to_channels_with_custom_channel_types**](docs/UserApi.md#register_as_operator_to_channels_with_custom_channel_types) | **POST** /v3/users/{user_id}/operating_channel_custom_types | Register as an operator to channels with custom channel types
*UserApi* | [**remove_registration_or_device_token**](docs/UserApi.md#remove_registration_or_device_token) | **DELETE** /v3/users/{user_id}/push | Remove a registration or device token - When unregistering all device tokens
*UserApi* | [**remove_registration_or_device_token_by_token**](docs/UserApi.md#remove_registration_or_device_token_by_token) | **DELETE** /v3/users/{user_id}/push/{token_type}/{token} | Remove a registration or device token - When unregistering a specific token
*UserApi* | [**remove_registration_or_device_token_from_owner_by_token**](docs/UserApi.md#remove_registration_or_device_token_from_owner_by_token) | **DELETE** /v3/push/device_tokens/{token_type}/{token} | Remove a registration or device token from an owner
*UserApi* | [**reset_push_preferences**](docs/UserApi.md#reset_push_preferences) | **DELETE** /v3/users/{user_id}/push_preference | Reset push preferences
*UserApi* | [**update_channel_invitation_preference**](docs/UserApi.md#update_channel_invitation_preference) | **PUT** /v3/users/{user_id}/channel_invitation_preference | Update channel invitation preference
*UserApi* | [**update_count_preference_of_channel_by_url**](docs/UserApi.md#update_count_preference_of_channel_by_url) | **PUT** /v3/users/{user_id}/count_preference/{channel_url} | Update count preference of a channel
*UserApi* | [**update_push_preferences**](docs/UserApi.md#update_push_preferences) | **PUT** /v3/users/{user_id}/push_preference | Update push preferences
*UserApi* | [**update_push_preferences_for_channel_by_url**](docs/UserApi.md#update_push_preferences_for_channel_by_url) | **PUT** /v3/users/{user_id}/push_preference/{channel_url} | Update push preferences for a channel
*UserApi* | [**update_user_by_id**](docs/UserApi.md#update_user_by_id) | **PUT** /v3/users/{user_id} | Update a user
*UserApi* | [**view_channel_invitation_preference**](docs/UserApi.md#view_channel_invitation_preference) | **GET** /v3/users/{user_id}/channel_invitation_preference | View channel invitation preference
*UserApi* | [**view_count_preference_of_channel_by_url**](docs/UserApi.md#view_count_preference_of_channel_by_url) | **GET** /v3/users/{user_id}/count_preference/{channel_url} | View count preference of a channel
*UserApi* | [**view_number_of_channels_by_join_status**](docs/UserApi.md#view_number_of_channels_by_join_status) | **GET** /v3/users/{user_id}/group_channel_count | View number of channels by join status
*UserApi* | [**view_number_of_channels_with_unread_messages**](docs/UserApi.md#view_number_of_channels_with_unread_messages) | **GET** /v3/users/{user_id}/unread_channel_count | View number of channels with unread messages
*UserApi* | [**view_number_of_unread_items**](docs/UserApi.md#view_number_of_unread_items) | **GET** /v3/users/{user_id}/unread_item_count | View number of unread items
*UserApi* | [**view_number_of_unread_messages**](docs/UserApi.md#view_number_of_unread_messages) | **GET** /v3/users/{user_id}/unread_message_count | View number of unread messages
*UserApi* | [**view_push_preferences**](docs/UserApi.md#view_push_preferences) | **GET** /v3/users/{user_id}/push_preference | View push preferences
*UserApi* | [**view_push_preferences_for_channel_by_url**](docs/UserApi.md#view_push_preferences_for_channel_by_url) | **GET** /v3/users/{user_id}/push_preference/{channel_url} | View push preferences for a channel
*UserApi* | [**view_user_by_id**](docs/UserApi.md#view_user_by_id) | **GET** /v3/users/{user_id} | View a user
*UserApi* | [**view_who_owns_registration_or_device_token_by_token**](docs/UserApi.md#view_who_owns_registration_or_device_token_by_token) | **GET** /v3/push/device_tokens/{token_type}/{token} | View who owns a registration or device token
*WebhookApi* | [**choose_which_events_to_subscribe_to**](docs/WebhookApi.md#choose_which_events_to_subscribe_to) | **PUT** /v3/applications/settings/webhook | Choose which events to subscribe to
*WebhookApi* | [**retrieve_list_of_subscribed_events**](docs/WebhookApi.md#retrieve_list_of_subscribed_events) | **GET** /v3/applications/settings/webhook | Retrieve a list of subscribed events


## Documentation For Models

 - [AddApnsPushConfigurationData](docs/AddApnsPushConfigurationData.md)
 - [AddApnsPushConfigurationResponse](docs/AddApnsPushConfigurationResponse.md)
 - [AddApnsPushConfigurationResponsePushConfigurationsInner](docs/AddApnsPushConfigurationResponsePushConfigurationsInner.md)
 - [AddEmojiCategoriesResponse](docs/AddEmojiCategoriesResponse.md)
 - [AddEmojiCategoriesResponseEmojiCategoriesInner](docs/AddEmojiCategoriesResponseEmojiCategoriesInner.md)
 - [AddEmojisData](docs/AddEmojisData.md)
 - [AddEmojisResponse](docs/AddEmojisResponse.md)
 - [AddExtraDataToMessageData](docs/AddExtraDataToMessageData.md)
 - [AddExtraDataToMessageResponse](docs/AddExtraDataToMessageResponse.md)
 - [AddFcmPushConfigurationData](docs/AddFcmPushConfigurationData.md)
 - [AddFcmPushConfigurationResponse](docs/AddFcmPushConfigurationResponse.md)
 - [AddFcmPushConfigurationResponsePushConfigurationsInner](docs/AddFcmPushConfigurationResponsePushConfigurationsInner.md)
 - [AddHmsPushConfigurationData](docs/AddHmsPushConfigurationData.md)
 - [AddHmsPushConfigurationResponse](docs/AddHmsPushConfigurationResponse.md)
 - [AddHmsPushConfigurationResponsePushConfigurationsInner](docs/AddHmsPushConfigurationResponsePushConfigurationsInner.md)
 - [AddIpToWhitelistData](docs/AddIpToWhitelistData.md)
 - [AddIpToWhitelistResponse](docs/AddIpToWhitelistResponse.md)
 - [AddReactionToAMessageData](docs/AddReactionToAMessageData.md)
 - [AddReactionToAMessageResponse](docs/AddReactionToAMessageResponse.md)
 - [AddRegistrationOrDeviceTokenData](docs/AddRegistrationOrDeviceTokenData.md)
 - [AddRegistrationOrDeviceTokenResponse](docs/AddRegistrationOrDeviceTokenResponse.md)
 - [BanFromChannelsWithCustomChannelTypesData](docs/BanFromChannelsWithCustomChannelTypesData.md)
 - [BanUsersInChannelsWithCustomChannelTypeData](docs/BanUsersInChannelsWithCustomChannelTypeData.md)
 - [BanUsersInChannelsWithCustomChannelTypeDataBannedListInner](docs/BanUsersInChannelsWithCustomChannelTypeDataBannedListInner.md)
 - [Blob](docs/Blob.md)
 - [BlockUserData](docs/BlockUserData.md)
 - [BlockUserResponse](docs/BlockUserResponse.md)
 - [ChoosePushNotificationContentTemplateResponse](docs/ChoosePushNotificationContentTemplateResponse.md)
 - [ChooseWhichEventsToSubscribeToData](docs/ChooseWhichEventsToSubscribeToData.md)
 - [ChooseWhichEventsToSubscribeToResponse](docs/ChooseWhichEventsToSubscribeToResponse.md)
 - [ChooseWhichEventsToSubscribeToResponseWebhook](docs/ChooseWhichEventsToSubscribeToResponseWebhook.md)
 - [ConfigureAutoEventData](docs/ConfigureAutoEventData.md)
 - [ConfigureAutoEventDataAutoEventMessage](docs/ConfigureAutoEventDataAutoEventMessage.md)
 - [CreateBotData](docs/CreateBotData.md)
 - [CreateBotResponse](docs/CreateBotResponse.md)
 - [CreateBotResponseBot](docs/CreateBotResponseBot.md)
 - [CreateChannelMetacounterData](docs/CreateChannelMetacounterData.md)
 - [CreateChannelMetadataData](docs/CreateChannelMetadataData.md)
 - [CreateChannelMetadataResponse](docs/CreateChannelMetadataResponse.md)
 - [CreateUserData](docs/CreateUserData.md)
 - [CreateUserMetadataData](docs/CreateUserMetadataData.md)
 - [CreateUserMetadataResponse](docs/CreateUserMetadataResponse.md)
 - [CreateUserResponse](docs/CreateUserResponse.md)
 - [CreateUserTokenData](docs/CreateUserTokenData.md)
 - [CreateUserTokenResponse](docs/CreateUserTokenResponse.md)
 - [CustomTypeListBannedUsersResponse](docs/CustomTypeListBannedUsersResponse.md)
 - [DeleteAllowedIpsFromWhitelistResponse](docs/DeleteAllowedIpsFromWhitelistResponse.md)
 - [DeleteApnsCertificateByIdResponse](docs/DeleteApnsCertificateByIdResponse.md)
 - [EnableReactionsData](docs/EnableReactionsData.md)
 - [EnableReactionsResponse](docs/EnableReactionsResponse.md)
 - [File](docs/File.md)
 - [Function](docs/Function.md)
 - [GcAcceptInvitationData](docs/GcAcceptInvitationData.md)
 - [GcAcceptInvitationResponse](docs/GcAcceptInvitationResponse.md)
 - [GcBanUserData](docs/GcBanUserData.md)
 - [GcBanUserResponse](docs/GcBanUserResponse.md)
 - [GcCheckIfMemberByIdResponse](docs/GcCheckIfMemberByIdResponse.md)
 - [GcCreateChannelData](docs/GcCreateChannelData.md)
 - [GcCreateChannelResponse](docs/GcCreateChannelResponse.md)
 - [GcDeclineInvitationData](docs/GcDeclineInvitationData.md)
 - [GcFreezeChannelData](docs/GcFreezeChannelData.md)
 - [GcFreezeChannelResponse](docs/GcFreezeChannelResponse.md)
 - [GcHideOrArchiveChannelData](docs/GcHideOrArchiveChannelData.md)
 - [GcInviteAsMembersData](docs/GcInviteAsMembersData.md)
 - [GcInviteAsMembersResponse](docs/GcInviteAsMembersResponse.md)
 - [GcJoinChannelData](docs/GcJoinChannelData.md)
 - [GcLeaveChannelData](docs/GcLeaveChannelData.md)
 - [GcListBannedUsersResponse](docs/GcListBannedUsersResponse.md)
 - [GcListChannelsResponse](docs/GcListChannelsResponse.md)
 - [GcListMembersResponse](docs/GcListMembersResponse.md)
 - [GcListMutedUsersResponse](docs/GcListMutedUsersResponse.md)
 - [GcListOperatorsResponse](docs/GcListOperatorsResponse.md)
 - [GcMarkAllMessagesAsDeliveredData](docs/GcMarkAllMessagesAsDeliveredData.md)
 - [GcMarkAllMessagesAsDeliveredResponse](docs/GcMarkAllMessagesAsDeliveredResponse.md)
 - [GcMarkAllMessagesAsReadData](docs/GcMarkAllMessagesAsReadData.md)
 - [GcMuteUserData](docs/GcMuteUserData.md)
 - [GcMuteUserResponse](docs/GcMuteUserResponse.md)
 - [GcRegisterOperatorsData](docs/GcRegisterOperatorsData.md)
 - [GcRegisterOperatorsResponse](docs/GcRegisterOperatorsResponse.md)
 - [GcResetChatHistoryData](docs/GcResetChatHistoryData.md)
 - [GcResetChatHistoryResponse](docs/GcResetChatHistoryResponse.md)
 - [GcUpdateBanByIdData](docs/GcUpdateBanByIdData.md)
 - [GcUpdateBanByIdResponse](docs/GcUpdateBanByIdResponse.md)
 - [GcUpdateChannelByUrlData](docs/GcUpdateChannelByUrlData.md)
 - [GcUpdateChannelByUrlResponse](docs/GcUpdateChannelByUrlResponse.md)
 - [GcViewBanByIdResponse](docs/GcViewBanByIdResponse.md)
 - [GcViewChannelByUrlResponse](docs/GcViewChannelByUrlResponse.md)
 - [GcViewMuteByIdResponse](docs/GcViewMuteByIdResponse.md)
 - [GcViewNumberOfEachMembersUnreadMessagesResponse](docs/GcViewNumberOfEachMembersUnreadMessagesResponse.md)
 - [GenerateSecondaryApiTokenData](docs/GenerateSecondaryApiTokenData.md)
 - [GenerateSecondaryApiTokenResponse](docs/GenerateSecondaryApiTokenResponse.md)
 - [GetDetailedOpenRateOfAnnouncementByIdResponse](docs/GetDetailedOpenRateOfAnnouncementByIdResponse.md)
 - [GetDetailedOpenRateOfAnnouncementGroupResponse](docs/GetDetailedOpenRateOfAnnouncementGroupResponse.md)
 - [GetDetailedOpenStatusOfAnnouncementByIdResponse](docs/GetDetailedOpenStatusOfAnnouncementByIdResponse.md)
 - [GetDetailedOpenStatusOfAnnouncementByIdResponseOpenStatusInner](docs/GetDetailedOpenStatusOfAnnouncementByIdResponseOpenStatusInner.md)
 - [GetEmojiByKeyResponse](docs/GetEmojiByKeyResponse.md)
 - [GetEmojiCategoryByIdResponse](docs/GetEmojiCategoryByIdResponse.md)
 - [GetStatisticsDailyResponse](docs/GetStatisticsDailyResponse.md)
 - [GetStatisticsDailyResponseStatisticsInner](docs/GetStatisticsDailyResponseStatisticsInner.md)
 - [GetStatisticsMonthlyResponse](docs/GetStatisticsMonthlyResponse.md)
 - [GetStatisticsResponse](docs/GetStatisticsResponse.md)
 - [JoinChannelsData](docs/JoinChannelsData.md)
 - [JoinChannelsResponse](docs/JoinChannelsResponse.md)
 - [LeaveMyGroupChannelsData](docs/LeaveMyGroupChannelsData.md)
 - [ListAllEmojisAndEmojiCategoriesResponse](docs/ListAllEmojisAndEmojiCategoriesResponse.md)
 - [ListAllEmojisAndEmojiCategoriesResponseEmojiCategoriesInner](docs/ListAllEmojisAndEmojiCategoriesResponseEmojiCategoriesInner.md)
 - [ListAllEmojisAndEmojiCategoriesResponseEmojiCategoriesInnerEmojisInner](docs/ListAllEmojisAndEmojiCategoriesResponseEmojiCategoriesInnerEmojisInner.md)
 - [ListAnnouncementGroupsResponse](docs/ListAnnouncementGroupsResponse.md)
 - [ListAnnouncementsResponse](docs/ListAnnouncementsResponse.md)
 - [ListAnnouncementsResponseAnnouncementsInner](docs/ListAnnouncementsResponseAnnouncementsInner.md)
 - [ListBannedChannelsResponse](docs/ListBannedChannelsResponse.md)
 - [ListBannedChannelsResponseBannedChannelsInner](docs/ListBannedChannelsResponseBannedChannelsInner.md)
 - [ListBlockedUsersResponse](docs/ListBlockedUsersResponse.md)
 - [ListBotsResponse](docs/ListBotsResponse.md)
 - [ListBotsResponseBotsInner](docs/ListBotsResponseBotsInner.md)
 - [ListDataExportsByMessageChannelOrUserResponse](docs/ListDataExportsByMessageChannelOrUserResponse.md)
 - [ListDataExportsByMessageChannelOrUserResponseExportedDataInner](docs/ListDataExportsByMessageChannelOrUserResponseExportedDataInner.md)
 - [ListDataExportsByMessageChannelOrUserResponseExportedDataInnerFile](docs/ListDataExportsByMessageChannelOrUserResponseExportedDataInnerFile.md)
 - [ListEmojisResponse](docs/ListEmojisResponse.md)
 - [ListGdprRequestsResponse](docs/ListGdprRequestsResponse.md)
 - [ListGdprRequestsResponseRequestsInner](docs/ListGdprRequestsResponseRequestsInner.md)
 - [ListMessagesResponse](docs/ListMessagesResponse.md)
 - [ListMessagesResponseMessagesInner](docs/ListMessagesResponseMessagesInner.md)
 - [ListMessagesResponseMessagesInnerOgTag](docs/ListMessagesResponseMessagesInnerOgTag.md)
 - [ListMessagesResponseMessagesInnerOgTagOgImage](docs/ListMessagesResponseMessagesInnerOgTagOgImage.md)
 - [ListMessagesResponseMessagesInnerSortedMetaarrayInner](docs/ListMessagesResponseMessagesInnerSortedMetaarrayInner.md)
 - [ListMutedChannelsResponse](docs/ListMutedChannelsResponse.md)
 - [ListMutedUsersInChannelsWithCustomChannelType200Response](docs/ListMutedUsersInChannelsWithCustomChannelType200Response.md)
 - [ListMyGroupChannelsResponse](docs/ListMyGroupChannelsResponse.md)
 - [ListPushConfigurationsResponse](docs/ListPushConfigurationsResponse.md)
 - [ListPushConfigurationsResponsePushConfigurationsInner](docs/ListPushConfigurationsResponsePushConfigurationsInner.md)
 - [ListPushNotificationContentTemplatesResponse](docs/ListPushNotificationContentTemplatesResponse.md)
 - [ListPushNotificationContentTemplatesResponsePushMessageTemplatesInner](docs/ListPushNotificationContentTemplatesResponsePushMessageTemplatesInner.md)
 - [ListPushNotificationContentTemplatesResponsePushMessageTemplatesInnerTemplate](docs/ListPushNotificationContentTemplatesResponsePushMessageTemplatesInnerTemplate.md)
 - [ListReactionsOfMessageResponse](docs/ListReactionsOfMessageResponse.md)
 - [ListRegistrationOrDeviceTokensResponse](docs/ListRegistrationOrDeviceTokensResponse.md)
 - [ListReportsOnChannelByUrlResponse](docs/ListReportsOnChannelByUrlResponse.md)
 - [ListReportsOnMessageByIdResponse](docs/ListReportsOnMessageByIdResponse.md)
 - [ListReportsOnMessageByIdResponseReportLogsInner](docs/ListReportsOnMessageByIdResponseReportLogsInner.md)
 - [ListReportsOnUserByIdResponse](docs/ListReportsOnUserByIdResponse.md)
 - [ListReportsResponse](docs/ListReportsResponse.md)
 - [ListReportsResponseReportLogsInner](docs/ListReportsResponseReportLogsInner.md)
 - [ListSecondaryApiTokensResponse](docs/ListSecondaryApiTokensResponse.md)
 - [ListSecondaryApiTokensResponseApiTokensInner](docs/ListSecondaryApiTokensResponseApiTokensInner.md)
 - [ListUsersResponse](docs/ListUsersResponse.md)
 - [MarkAllMessagesAsReadData](docs/MarkAllMessagesAsReadData.md)
 - [MuteInChannelsWithCustomChannelTypesData](docs/MuteInChannelsWithCustomChannelTypesData.md)
 - [MuteUsersInChannelsWithCustomChannelTypeData](docs/MuteUsersInChannelsWithCustomChannelTypeData.md)
 - [OcBanUserData](docs/OcBanUserData.md)
 - [OcBanUserResponse](docs/OcBanUserResponse.md)
 - [OcCreateChannelData](docs/OcCreateChannelData.md)
 - [OcCreateChannelResponse](docs/OcCreateChannelResponse.md)
 - [OcDeleteChannelByUrl200Response](docs/OcDeleteChannelByUrl200Response.md)
 - [OcFreezeChannelData](docs/OcFreezeChannelData.md)
 - [OcFreezeChannelResponse](docs/OcFreezeChannelResponse.md)
 - [OcListBannedUsersResponse](docs/OcListBannedUsersResponse.md)
 - [OcListBannedUsersResponseBannedListInner](docs/OcListBannedUsersResponseBannedListInner.md)
 - [OcListChannelsResponse](docs/OcListChannelsResponse.md)
 - [OcListMutedUsersResponse](docs/OcListMutedUsersResponse.md)
 - [OcListOperatorsResponse](docs/OcListOperatorsResponse.md)
 - [OcListParticipantsResponse](docs/OcListParticipantsResponse.md)
 - [OcMuteUserData](docs/OcMuteUserData.md)
 - [OcMuteUserResponse](docs/OcMuteUserResponse.md)
 - [OcRegisterOperatorsData](docs/OcRegisterOperatorsData.md)
 - [OcUpdateBanByIdData](docs/OcUpdateBanByIdData.md)
 - [OcUpdateBanByIdResponse](docs/OcUpdateBanByIdResponse.md)
 - [OcUpdateChannelByUrlData](docs/OcUpdateChannelByUrlData.md)
 - [OcUpdateChannelByUrlResponse](docs/OcUpdateChannelByUrlResponse.md)
 - [OcViewBanByIdResponse](docs/OcViewBanByIdResponse.md)
 - [OcViewChannelByUrlResponse](docs/OcViewChannelByUrlResponse.md)
 - [OcViewMuteByIdResponse](docs/OcViewMuteByIdResponse.md)
 - [RegisterAndScheduleDataExportData](docs/RegisterAndScheduleDataExportData.md)
 - [RegisterAndScheduleDataExportResponse](docs/RegisterAndScheduleDataExportResponse.md)
 - [RegisterAsOperatorToChannelsWithCustomChannelTypesData](docs/RegisterAsOperatorToChannelsWithCustomChannelTypesData.md)
 - [RegisterGdprRequestData](docs/RegisterGdprRequestData.md)
 - [RegisterGdprRequestResponse](docs/RegisterGdprRequestResponse.md)
 - [RemovePushConfigurationByIdResponse](docs/RemovePushConfigurationByIdResponse.md)
 - [RemoveReactionFromAMessageResponse](docs/RemoveReactionFromAMessageResponse.md)
 - [RemoveRegistrationOrDeviceTokenByTokenResponse](docs/RemoveRegistrationOrDeviceTokenByTokenResponse.md)
 - [RemoveRegistrationOrDeviceTokenFromOwnerByTokenResponse](docs/RemoveRegistrationOrDeviceTokenFromOwnerByTokenResponse.md)
 - [RemoveRegistrationOrDeviceTokenResponse](docs/RemoveRegistrationOrDeviceTokenResponse.md)
 - [ReportChannelByUrlData](docs/ReportChannelByUrlData.md)
 - [ReportChannelByUrlResponse](docs/ReportChannelByUrlResponse.md)
 - [ReportMessageByIdData](docs/ReportMessageByIdData.md)
 - [ReportMessageByIdResponse](docs/ReportMessageByIdResponse.md)
 - [ReportUserByIdData](docs/ReportUserByIdData.md)
 - [ReportUserByIdResponse](docs/ReportUserByIdResponse.md)
 - [ResetPushPreferencesResponse](docs/ResetPushPreferencesResponse.md)
 - [RetrieveAdvancedAnalyticsMetricsResponse](docs/RetrieveAdvancedAnalyticsMetricsResponse.md)
 - [RetrieveIpWhitelistResponse](docs/RetrieveIpWhitelistResponse.md)
 - [RetrieveListOfSubscribedEventsResponse](docs/RetrieveListOfSubscribedEventsResponse.md)
 - [RetrieveListOfSubscribedEventsResponseWebhook](docs/RetrieveListOfSubscribedEventsResponseWebhook.md)
 - [RevokeSecondaryApiTokenByTokenResponse](docs/RevokeSecondaryApiTokenByTokenResponse.md)
 - [SBObject](docs/SBObject.md)
 - [ScheduleAnnouncementData](docs/ScheduleAnnouncementData.md)
 - [ScheduleAnnouncementDataMessage](docs/ScheduleAnnouncementDataMessage.md)
 - [ScheduleAnnouncementResponse](docs/ScheduleAnnouncementResponse.md)
 - [ScheduleAnnouncementResponseCreateChannelOptions](docs/ScheduleAnnouncementResponseCreateChannelOptions.md)
 - [ScheduleAnnouncementResponseMessage](docs/ScheduleAnnouncementResponseMessage.md)
 - [SendBirdAdminMessage](docs/SendBirdAdminMessage.md)
 - [SendBirdAppleCriticalAlertOptions](docs/SendBirdAppleCriticalAlertOptions.md)
 - [SendBirdAutoEventMessageSettings](docs/SendBirdAutoEventMessageSettings.md)
 - [SendBirdBaseChannel](docs/SendBirdBaseChannel.md)
 - [SendBirdBaseMessageInstance](docs/SendBirdBaseMessageInstance.md)
 - [SendBirdChannelResponse](docs/SendBirdChannelResponse.md)
 - [SendBirdEmoji](docs/SendBirdEmoji.md)
 - [SendBirdEmojiCategory](docs/SendBirdEmojiCategory.md)
 - [SendBirdFileMessageParams](docs/SendBirdFileMessageParams.md)
 - [SendBirdGroupChannel](docs/SendBirdGroupChannel.md)
 - [SendBirdGroupChannelChannel](docs/SendBirdGroupChannelChannel.md)
 - [SendBirdGroupChannelCollection](docs/SendBirdGroupChannelCollection.md)
 - [SendBirdGroupChannelCreatedBy](docs/SendBirdGroupChannelCreatedBy.md)
 - [SendBirdGroupChannelDisappearingMessage](docs/SendBirdGroupChannelDisappearingMessage.md)
 - [SendBirdGroupChannelInviter](docs/SendBirdGroupChannelInviter.md)
 - [SendBirdGroupChannelLastMessage](docs/SendBirdGroupChannelLastMessage.md)
 - [SendBirdGroupChannelSmsFallback](docs/SendBirdGroupChannelSmsFallback.md)
 - [SendBirdMember](docs/SendBirdMember.md)
 - [SendBirdMessageMetaArray](docs/SendBirdMessageMetaArray.md)
 - [SendBirdMessageResponse](docs/SendBirdMessageResponse.md)
 - [SendBirdMessageResponseMentionedUsersInner](docs/SendBirdMessageResponseMentionedUsersInner.md)
 - [SendBirdMessageResponseUser](docs/SendBirdMessageResponseUser.md)
 - [SendBirdOGImage](docs/SendBirdOGImage.md)
 - [SendBirdOGMetaData](docs/SendBirdOGMetaData.md)
 - [SendBirdOpenChannel](docs/SendBirdOpenChannel.md)
 - [SendBirdPlugin](docs/SendBirdPlugin.md)
 - [SendBirdPoll](docs/SendBirdPoll.md)
 - [SendBirdPollDetails](docs/SendBirdPollDetails.md)
 - [SendBirdPollOption](docs/SendBirdPollOption.md)
 - [SendBirdPollUpdatedVoteCount](docs/SendBirdPollUpdatedVoteCount.md)
 - [SendBirdReaction](docs/SendBirdReaction.md)
 - [SendBirdRestrictionInfo](docs/SendBirdRestrictionInfo.md)
 - [SendBirdSender](docs/SendBirdSender.md)
 - [SendBirdThreadInfo](docs/SendBirdThreadInfo.md)
 - [SendBirdThumbnailSBObject](docs/SendBirdThumbnailSBObject.md)
 - [SendBirdThumbnailSize](docs/SendBirdThumbnailSize.md)
 - [SendBirdUser](docs/SendBirdUser.md)
 - [SendBirdUserMessageParams](docs/SendBirdUserMessageParams.md)
 - [SendBotSMessageData](docs/SendBotSMessageData.md)
 - [SendBotsMessageResponse](docs/SendBotsMessageResponse.md)
 - [SendMessageData](docs/SendMessageData.md)
 - [SendMessageResponse](docs/SendMessageResponse.md)
 - [SetDomainFilterData](docs/SetDomainFilterData.md)
 - [SetDomainFilterDataDomainFilter](docs/SetDomainFilterDataDomainFilter.md)
 - [SetDomainFilterDataImageModeration](docs/SetDomainFilterDataImageModeration.md)
 - [SetDomainFilterDataImageModerationLimits](docs/SetDomainFilterDataImageModerationLimits.md)
 - [SetDomainFilterDataProfanityFilter](docs/SetDomainFilterDataProfanityFilter.md)
 - [SetDomainFilterDataProfanityFilterRegexFiltersInner](docs/SetDomainFilterDataProfanityFilterRegexFiltersInner.md)
 - [SetDomainFilterDataProfanityTriggeredModeration](docs/SetDomainFilterDataProfanityTriggeredModeration.md)
 - [TranslateMessageIntoOtherLanguagesData](docs/TranslateMessageIntoOtherLanguagesData.md)
 - [TranslateMessageIntoOtherLanguagesResponse](docs/TranslateMessageIntoOtherLanguagesResponse.md)
 - [UpdateAnnouncementByIdData](docs/UpdateAnnouncementByIdData.md)
 - [UpdateAnnouncementByIdResponse](docs/UpdateAnnouncementByIdResponse.md)
 - [UpdateAnnouncementByIdResponseMessage](docs/UpdateAnnouncementByIdResponseMessage.md)
 - [UpdateApnsPushConfigurationByIdData](docs/UpdateApnsPushConfigurationByIdData.md)
 - [UpdateApnsPushConfigurationByIdResponse](docs/UpdateApnsPushConfigurationByIdResponse.md)
 - [UpdateBotByIdData](docs/UpdateBotByIdData.md)
 - [UpdateBotByIdResponse](docs/UpdateBotByIdResponse.md)
 - [UpdateChannelInvitationPreferenceData](docs/UpdateChannelInvitationPreferenceData.md)
 - [UpdateChannelInvitationPreferenceResponse](docs/UpdateChannelInvitationPreferenceResponse.md)
 - [UpdateChannelMetacounterByKeyResponse](docs/UpdateChannelMetacounterByKeyResponse.md)
 - [UpdateChannelMetacounterData](docs/UpdateChannelMetacounterData.md)
 - [UpdateChannelMetadataByKeyResponse](docs/UpdateChannelMetadataByKeyResponse.md)
 - [UpdateChannelMetadataData](docs/UpdateChannelMetadataData.md)
 - [UpdateChannelMetadataResponse](docs/UpdateChannelMetadataResponse.md)
 - [UpdateCountPreferenceOfChannelByUrlData](docs/UpdateCountPreferenceOfChannelByUrlData.md)
 - [UpdateCountPreferenceOfChannelByUrlResponse](docs/UpdateCountPreferenceOfChannelByUrlResponse.md)
 - [UpdateDefaultChannelInvitationPreferenceData](docs/UpdateDefaultChannelInvitationPreferenceData.md)
 - [UpdateDefaultChannelInvitationPreferenceResponse](docs/UpdateDefaultChannelInvitationPreferenceResponse.md)
 - [UpdateEmojiCategoryUrlByIdData](docs/UpdateEmojiCategoryUrlByIdData.md)
 - [UpdateEmojiCategoryUrlByIdResponse](docs/UpdateEmojiCategoryUrlByIdResponse.md)
 - [UpdateEmojiUrlByKeyData](docs/UpdateEmojiUrlByKeyData.md)
 - [UpdateEmojiUrlByKeyResponse](docs/UpdateEmojiUrlByKeyResponse.md)
 - [UpdateExtraDataInMessageData](docs/UpdateExtraDataInMessageData.md)
 - [UpdateExtraDataInMessageResponse](docs/UpdateExtraDataInMessageResponse.md)
 - [UpdateExtraDataInMessageResponseSortedMetaarrayInner](docs/UpdateExtraDataInMessageResponseSortedMetaarrayInner.md)
 - [UpdateFcmPushConfigurationByIdData](docs/UpdateFcmPushConfigurationByIdData.md)
 - [UpdateFcmPushConfigurationByIdResponse](docs/UpdateFcmPushConfigurationByIdResponse.md)
 - [UpdateHmsPushConfigurationByIdData](docs/UpdateHmsPushConfigurationByIdData.md)
 - [UpdateHmsPushConfigurationByIdResponse](docs/UpdateHmsPushConfigurationByIdResponse.md)
 - [UpdateMessageByIdData](docs/UpdateMessageByIdData.md)
 - [UpdateMessageByIdResponse](docs/UpdateMessageByIdResponse.md)
 - [UpdatePushNotificationContentTemplateData](docs/UpdatePushNotificationContentTemplateData.md)
 - [UpdatePushNotificationContentTemplateResponse](docs/UpdatePushNotificationContentTemplateResponse.md)
 - [UpdatePushPreferencesData](docs/UpdatePushPreferencesData.md)
 - [UpdatePushPreferencesForChannelByUrlData](docs/UpdatePushPreferencesForChannelByUrlData.md)
 - [UpdatePushPreferencesForChannelByUrlResponse](docs/UpdatePushPreferencesForChannelByUrlResponse.md)
 - [UpdatePushPreferencesResponse](docs/UpdatePushPreferencesResponse.md)
 - [UpdateUserByIdData](docs/UpdateUserByIdData.md)
 - [UpdateUserByIdResponse](docs/UpdateUserByIdResponse.md)
 - [UpdateUserMetadataByKeyResponse](docs/UpdateUserMetadataByKeyResponse.md)
 - [UpdateUserMetadataData](docs/UpdateUserMetadataData.md)
 - [UpdateUserMetadataResponse](docs/UpdateUserMetadataResponse.md)
 - [UseDefaultEmojisData](docs/UseDefaultEmojisData.md)
 - [UseDefaultEmojisResponse](docs/UseDefaultEmojisResponse.md)
 - [ViewAnnouncementByIdResponse](docs/ViewAnnouncementByIdResponse.md)
 - [ViewBotByIdResponse](docs/ViewBotByIdResponse.md)
 - [ViewChannelInvitationPreferenceResponse](docs/ViewChannelInvitationPreferenceResponse.md)
 - [ViewChannelMetacounterResponse](docs/ViewChannelMetacounterResponse.md)
 - [ViewChannelMetadataByKeyResponse](docs/ViewChannelMetadataByKeyResponse.md)
 - [ViewChannelMetadataResponse](docs/ViewChannelMetadataResponse.md)
 - [ViewCountPreferenceOfChannelByUrlResponse](docs/ViewCountPreferenceOfChannelByUrlResponse.md)
 - [ViewDataExportByIdResponse](docs/ViewDataExportByIdResponse.md)
 - [ViewDefaultChannelInvitationPreferenceResponse](docs/ViewDefaultChannelInvitationPreferenceResponse.md)
 - [ViewGdprRequestByIdResponse](docs/ViewGdprRequestByIdResponse.md)
 - [ViewMessageByIdResponse](docs/ViewMessageByIdResponse.md)
 - [ViewNumberOfChannelsByJoinStatusResponse](docs/ViewNumberOfChannelsByJoinStatusResponse.md)
 - [ViewNumberOfChannelsWithUnreadMessagesResponse](docs/ViewNumberOfChannelsWithUnreadMessagesResponse.md)
 - [ViewNumberOfConcurrentConnectionsResponse](docs/ViewNumberOfConcurrentConnectionsResponse.md)
 - [ViewNumberOfDailyActiveUsersResponse](docs/ViewNumberOfDailyActiveUsersResponse.md)
 - [ViewNumberOfMonthlyActiveUsersResponse](docs/ViewNumberOfMonthlyActiveUsersResponse.md)
 - [ViewNumberOfPeakConnectionsResponse](docs/ViewNumberOfPeakConnectionsResponse.md)
 - [ViewNumberOfPeakConnectionsResponsePeakConnectionsInner](docs/ViewNumberOfPeakConnectionsResponsePeakConnectionsInner.md)
 - [ViewNumberOfUnreadItemsResponse](docs/ViewNumberOfUnreadItemsResponse.md)
 - [ViewNumberOfUnreadMessagesResponse](docs/ViewNumberOfUnreadMessagesResponse.md)
 - [ViewPushConfigurationByIdResponse](docs/ViewPushConfigurationByIdResponse.md)
 - [ViewPushNotificationContentTemplateResponse](docs/ViewPushNotificationContentTemplateResponse.md)
 - [ViewPushNotificationContentTemplateResponsePushMessageTemplatesInner](docs/ViewPushNotificationContentTemplateResponsePushMessageTemplatesInner.md)
 - [ViewPushPreferencesForChannelByUrlResponse](docs/ViewPushPreferencesForChannelByUrlResponse.md)
 - [ViewPushPreferencesResponse](docs/ViewPushPreferencesResponse.md)
 - [ViewSecondaryApiTokenByTokenResponse](docs/ViewSecondaryApiTokenByTokenResponse.md)
 - [ViewTotalNumberOfMessagesInChannelResponse](docs/ViewTotalNumberOfMessagesInChannelResponse.md)
 - [ViewUserByIdResponse](docs/ViewUserByIdResponse.md)
 - [ViewUserMetadataByKeyResponse](docs/ViewUserMetadataByKeyResponse.md)
 - [ViewUserMetadataResponse](docs/ViewUserMetadataResponse.md)
 - [ViewWhoOwnsRegistrationOrDeviceTokenByTokenResponse](docs/ViewWhoOwnsRegistrationOrDeviceTokenByTokenResponse.md)
 - [ViewWhoOwnsRegistrationOrDeviceTokenByTokenResponseInner](docs/ViewWhoOwnsRegistrationOrDeviceTokenByTokenResponseInner.md)


## Documentation For Authorization

 All endpoints do not require authorization.

## Author

support@sendbird.com


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in sendbird_platform_sdk.apis and sendbird_platform_sdk.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from sendbird_platform_sdk.api.default_api import DefaultApi`
- `from sendbird_platform_sdk.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import sendbird_platform_sdk
from sendbird_platform_sdk.apis import *
from sendbird_platform_sdk.models import *
```

